#include "DHTListener.h"
#include "bdict.h"
#include <kademlia/kademlia.hpp>

using namespace kademlia;

CDHTListener::CDHTListener(IBTTask* task)
{
	m_connection = new CUDPListener();
	setBTTask(task);
	m_connection->start();
}

CDHTListener::~CDHTListener()
{
	debugger::send(NETWORK, "fuction called but not implemented, fixme");
}

bool  CDHTListener::add_contact (contact_type *contact_ptr, bool keep)
{
	debugger::send(NETWORK, "fuction called but not implemented, fixme");
}

void CDHTListener::setBTTask(IBTTask* task)
{
	_task = task;
	m_connection->setBTTask(_task);
}

IBTTask* CDHTListener::getBTTask()
{
	return _task;
}

bool CDHTListener::is_connected()
{
	debugger::send(NETWORK, "fuction called but not implemented, fixme");
}

void CDHTListener::send_HELLO(std::string const& client, int port)
{
	CBDict outpacket ,*kad_id;
	outpacket.append("t", "0");
	outpacket.append("y", "q");
	outpacket.append("q", "ping");
	kad_id = new CBDict();
	kad_id->append("id",kad<uint_type, debugger>::get_kad_id().get_hex_string());
	outpacket.append("a",kad_id);
	std::string pkgstr;
	outpacket.get_bestr(pkgstr);
	m_connection->sendto(pkgstr.c_str(),
			pkgstr.length(),
			client,
			port);

	debugger::send(NETWORK, "A PING sent to %s:%d", client.c_str(), port);
}


void CDHTListener::send_HELLO(contact_type *contact_ptr)
{
			send_HELLO(contact_ptr->get_ip(), contact_ptr->get_port());

}

void CDHTListener::send_BOOTSTRAP_REQUEST(contact_type *contact_ptr)
{
	debugger::send(NETWORK, "fuction called but not implemented, fixme");
}


void CDHTListener::send_BOOSTRAP_REQUEST(std::string const& host, std::string const& port)
{
	debugger::send(NETWORK, "fuction called but not implemented, fixme");
}

void CDHTListener::send_NODE_LOOKUP_REQUEST(uint_type const& target_id,
			uint_type const& session_id,
			contact_type *contact_ptr)
{
	debugger::send(NETWORK, "fuction called but not implemented, fixme");
}

void CDHTListener::send_STORE_VALUE(uint_type const& target_id,
			std::string const& content,
			std::string const& arguments,
			contact_type* contact_ptr)
{
	debugger::send(NETWORK, "fuction called but not implemented, fixme");
}

void CDHTListener::send_SEARCH_REQUEST(uint_type const& target_id,
			uint_type const& session_id,
			std::string const& arguments,
			contact_type* contact_ptr)
{
	debugger::send(NETWORK, "fuction called but not implemented, fixme");
}


void CDHTListener::processPkg(const char* buf, int len, std::string const& client, int port)
{

	debugger::send(NETWORK, "fuction called but not implemented, fixme");
}
