#include "DHTManager.h"
#include <kademlia/kademlia.hpp>
#include <kademlia/utils/uint160.hpp>
#include "dhtdebug.h"
#include "DHTListener.h"
#include "bdict.h"
#include "blist.h"
#include "log.h"

typedef kademlia::kad<uint160, dhtdebug> dht_type;
CDHTManager::CDHTManager()
{
}

CDHTManager::~CDHTManager()
{

}

bool CDHTManager::start()
{
	dht_type::start();
	dht_type::set_listener(new CDHTListener(_task));

	for(unsigned int i = 0; i < _task->getTorrentFile()->getNodesCount(); ++i)
	{
		CBList *node = (CBList *)_task->getTorrentFile()->getNode(i);
		if(node != NULL)
		{
			CBString *ip = (CBString*)node->getValue(0);
			LOG_ERROR("send to dht node: " << ip->getValue());
			CBInteger *port = (CBInteger*)node->getValue(1);
			dht_type::get_listener()->send_HELLO(ip->getValue(),port->getValue());
		}
	}
		

	return true;
}

void CDHTManager::setBTTask(IBTTask* task)
{
	_task = task;
}

IBTTask* CDHTManager::getBTTask()
{
	return _task;
}


