/*
 * Author:	Geroge Ang
 * Create data:	2007-02-10 02:09
 */
 
#ifndef DHTTRACKER_H_
#define DHTTRACKER_H_

#include <pthread.h>
#include <list>
#include "BitStorm.h"


class CDHTTracker : public ITracker, ITrackerManager
{
public:
	CDHTTracker();
	virtual ~CDHTTracker();
private:
	pthread_t _thrHandle;
	bool _toExit;
	IBTTask* _task;
	unsigned int _peerCount;
	unsigned int _seedCount;
private:
	void createTrackers();	
	void stopTrackers();	
	void destroyTrackers();
public:
	void setBTTask(IBTTask* task);
	IBTTask* getBTTask();
	
 	bool start();
	void stop();		
	unsigned int getSeedCount();
	unsigned int getPeerCount();	
	
	int svc();
};

#endif /*DHTTRACKER_H_*/
